on construct(me)
  if the runMode = "Author" then
    pFileExtension = ".cst"
  else
    pFileExtension = ".cct"
  end if
  pLoadedCasts = []
  pTempWaitList = []
  pCastLibCount = 0
  pNullCastName = "empty"
  pSysCastNum = castLib("fuse_client").number
  pBinCastNum = castLib(getVariable("dynamic.bin.cast")).number
  pLastError = 0
  pDontProfile = 1
  me.verifyReset()
  return(1)
  exit
end

on startCastLoad(me, tCasts, tPermanentFlag, tAdd, tDoIndexing, tDoTracking)
  if voidp(tPermanentFlag) then
    tPermanentFlag = 0
  end if
  if voidp(tAdd) then
    tAdd = 0
  end if
  if voidp(tDoIndexing) then
    tDoIndexing = 1
  end if
  if voidp(tDoTracking) then
    tDoTracking = 0
  end if
  pLastError = 0
  if tDoTracking then
    tCastsStr = "" & tCasts
    tCastsStr = replaceChunks(tCastsStr, "\"", "")
    tCastsStr = replaceChunks(tCastsStr, " ", "")
    tCastsStr = replaceChunks(tCastsStr, "[", "")
    tCastsStr = replaceChunks(tCastsStr, "]", "")
    tCastsStr = replaceChunks(tCastsStr, "\r", "")
  end if
  pTempWaitList = []
  tCastList = []
  if me = #propList then
    f = 1
    repeat while f <= tCasts.count
      tPermanentLevel = tCasts.getPropAt(f)
      tCastName = tCasts.getAt(f)
      tCastList.add(tCastName)
      me.addOneCastToWaitList(tCastName, tPermanentLevel)
      f = 1 + f
    end repeat
    exit repeat
  end if
  if me = #list then
    repeat while me <= tPermanentFlag
      tCastName = getAt(tPermanentFlag, tCasts)
      tCastList.add(tCastName)
      me.addOneCastToWaitList(tCastName, tPermanentFlag)
    end repeat
  else
    tCasts = list(tCasts)
    repeat while me <= tPermanentFlag
      tCastName = getAt(tPermanentFlag, tCasts)
      tCastList.add(tCastName)
      me.addOneCastToWaitList(tCastName, tPermanentFlag)
    end repeat
  end if
  if count(tCasts) = 0 then
    return(0)
  end if
  tID = getUniqueID()
  pLatestTaskID = tID
  if tAdd = 0 then
    me.removeTemporaryCast(tCastList)
  end if
  if pTempWaitList.count > 0 then
    pWaitList.setAt(tID, pTempWaitList.duplicate())
  end if
  if pWaitList.count = 0 then
    tStatus = #ready
    tPercent = 0
  else
    tStatus = #LOADING
    tPercent = 0
  end if
  pTaskList.setAt(tID, createObject(#temp, getClassVariable("castload.task.class")))
  tProps = []
  tProps.setAt(#id, tID)
  tProps.setAt(#status, tStatus)
  tProps.setAt(#Percent, tPercent)
  tProps.setAt(#sofar, 0)
  tProps.setAt(#casts, pTempWaitList.duplicate())
  tProps.setAt(#callback, void())
  tProps.setAt(#doindexing, tDoIndexing)
  pTaskList.getAt(tID).define(tProps)
  pLastError = 0
  i = 1
  repeat while i <= getIntVariable("net.operation.count", 2)
    me.AddNextpreloadNetThing()
    i = 1 + i
  end repeat
  return(tID)
  exit
end

on registerCallback(me, tID, tMethod, tClientID, tArgument)
  if voidp(pTaskList.findPos(tID)) then
    return(0)
  else
    return(call(#addCallBack, pTaskList.getAt(tID), tID, tMethod, tClientID, tArgument))
  end if
  exit
end

on resetCastLibs(me, tClean, tForced)
  if tClean <> 1 then
    tClean = 0
  end if
  tTempList = []
  if the runMode = "Author" and tForced <> 1 then
    f = 1
    repeat while 1
      if variableExists("cast.dev." & f) then
        tTempList.add(getVariable("cast.dev." & f))
      else
      end if
      f = f + 1
    end repeat
  end if
  pCastLibCount = the number of undefineds
  tEmptyCastNum = 1
  tCastNum = 2
  repeat while tCastNum <= pCastLibCount
    if tCastNum <> pSysCastNum and tCastNum <> pBinCastNum then
      tCastName = castLib(tCastNum).name
      if tTempList.findPos(tCastName) = 0 then
        if tClean then
          getThreadManager().closeThread(tCastNum)
        end if
        if tClean then
          getResourceManager().unregisterMembers(tCastNum)
        end if
        castLib(tCastNum).name = pNullCastName && tEmptyCastNum
        castLib(tCastNum).fileName = getMoviePath() & pNullCastName & pFileExtension
        tEmptyCastNum = tEmptyCastNum + 1
      else
        pLoadedCasts.setAt(tCastName, string(tCastNum))
      end if
    end if
    tCastNum = 1 + tCastNum
  end repeat
  return(me.InitPreloader())
  exit
end

on getLoadPercent(me, tID)
  if voidp(tID) then
    tID = pLatestTaskID
  end if
  if not voidp(pTaskList.getaProp(tID)) then
    if pTaskList.getaProp(tID).getTaskState() = #ready then
      return(0)
    else
      return(pTaskList.getaProp(tID).getTaskPercent())
    end if
  else
    return(0)
  end if
  exit
end

on FindCastNumber(me, tCast)
  j = 1
  repeat while j <= the number of undefineds
    tFileName = castLib(j).fileName
    tFileExtension = tFileName.getProp(#char, length(tFileName) - 2, length(tFileName))
    if castLib(j).name <> "Internal" and tFileExtension <> "dcr" and tFileExtension <> "dir" then
      if castLib(j).name = tCast then
        return(castLib(tCast).number)
      else
        j = 1 + j
      end if
      return(0)
      exit
    end if
  end repeat
end

on exists(me, tCastName)
  if tCastName = "internal" then
    return(1)
  end if
  if voidp(pLoadedCasts.getAt(tCastName)) then
    return(0)
  else
    return(1)
  end if
  exit
end

on print(me)
  i = 1
  repeat while i <= the number of undefineds
    put(castLib(i).name)
    i = 1 + i
  end repeat
  repeat while me <= undefined
    tObj = getAt(undefined, undefined)
    put(tObj.getAt(#pFile) && tObj.getAt(#pPercent))
  end repeat
  exit
end

on GetLastError(me)
  return(pLastError)
  exit
end

on prepare(me)
  if count(pTaskList) > 0 then
    if getObjectManager().managerExists(#variable_manager) then
      if variableExists("profile.core.enabled") then
        pDontProfile = 0
      end if
    end if
    me.AddNextpreloadNetThing()
    call(#resetPercentCounter, pTaskList)
    if pDontProfile then
      call(#update, pCurrentDownLoads)
    else
      i = 1
      repeat while i <= pCurrentDownLoads.count
        tTask = pCurrentDownLoads.getAt(i)
        tTaskName = "Update Castload Task " & tTask.pURL
        startProfilingTask(tTaskName)
        call(#update, [tTask])
        finishProfilingTask(tTaskName)
        i = 1 + i
      end repeat
    end if
  end if
  exit
end

on InitPreloader(me)
  pWaitList = []
  pTaskList = []
  pAvailableDynCasts = []
  pPermanentLevelList = []
  pCurrentDownLoads = []
  pLatestTaskID = ""
  f = 1
  repeat while f <= the number of undefineds
    tCastNumber = me.FindCastNumber(pNullCastName && f)
    if tCastNumber > 0 then
      pAvailableDynCasts.addProp(pNullCastName && f, tCastNumber)
    end if
    f = 1 + f
  end repeat
  return(1)
  exit
end

on AddNextpreloadNetThing(me)
  if pCurrentDownLoads.count < getIntVariable("net.operation.count", 2) then
    if pWaitList.count > 0 then
      if count(pWaitList.getAt(1)) > 0 then
        tFile = pWaitList.getAt(1).getAt(1)
        tParsedFile = tFile
        tFileExtension = pFileExtension
        tURL = ""
        tParamOffset = offset("?", tFile)
        tParamString = ""
        if tParamOffset > 0 then
          tParamString = tFile.getProp(#char, tParamOffset, tFile.length)
          tFile = tFile.getProp(#char, 1, tParamOffset - 1)
        end if
        tPossibleExtension = chars(tFile, tFile.length - 3, tFile.length)
        if tPossibleExtension = ".cst" or tPossibleExtension = ".cct" then
          tFileExtension = tPossibleExtension
          tParsedFile = chars(tFile, 1, tFile.length - tPossibleExtension.length)
        end if
        if tParsedFile contains "http://" or tParsedFile contains "https://" then
          if the runMode contains "Author" then
            tURL = tParsedFile & tFileExtension & tParamString
          else
            tClientDomain = me.getDomainAndTld(getMoviePath())
            tUrlDomain = me.getDomainAndTld(tParsedFile)
            if tClientDomain <> tUrlDomain then
              tURL = tParsedFile & tFileExtension & tParamString
              error(me, "Cross domain not allowed:" && tURL, #addPreloadNetThing, #critical)
              fatalError(["error":"cross_domain_castload"])
              return(0)
            else
              tURL = tParsedFile & tFileExtension & tParamString
            end if
          end if
        else
          tURL = getMoviePath() & tParsedFile & tFileExtension & tParamString
        end if
        tID = pWaitList.getPropAt(1)
        pWaitList.getAt(1).deleteAt(1)
        if count(pWaitList.getAt(1)) = 0 then
          pWaitList.deleteProp(pWaitList.getPropAt(1))
        end if
        pCurrentDownLoads.setAt(tFile, createObject(#temp, getClassVariable("castload.instance.class")))
        pCurrentDownLoads.getAt(tFile).define(tFile, tURL, tID)
        pTaskList.getAt(tID).changeLoadingCount(1)
        receivePrepare(me.getID())
        return(1)
      end if
    end if
  end if
  return(0)
  exit
end

on getDomainAndTld(me, tURL)
  if ilk(tURL) <> #string then
    return(tURL)
  end if
  if offset("?", tURL) > 0 then
    tURL = chars(tURL, 0, offset("?", tURL) - 1)
  end if
  if chars(tURL, tURL.length, tURL.length) = "/" then
    tURL = chars(tURL, 0, tURL.length - 1)
  end if
  tDelim = the itemDelimiter
  if tURL contains "http://" or tURL contains "https://" then
    the itemDelimiter = "/"
    tURL = tURL.getProp(#item, 3)
  else
    tURL = tURL.getProp(#item, 1)
  end if
  the itemDelimiter = "."
  tTldItemCount = 1
  tDomain = ""
  if tURL.count(#item) = 1 then
    tDomain = tURL
  else
    if tURL.count(#item) = 2 then
      tDomain = tURL.getProp(#item, 1)
    else
      tTldCount = 1
      tDomainStrLength = tURL.getPropRef(#item, tURL.count(#item) - 1).length
      if tDomainStrLength = 2 or tDomainStrLength = 3 then
        tTldItemCount = 2
      end if
      tDomain = tURL.getProp(#item, tURL.count(#item) - tTldItemCount)
    end if
  end if
  the itemDelimiter = tDelim
  return(tDomain)
  exit
end

on DoneCurrentDownLoad(me, tFile, tURL, tID, tstate)
  if voidp(pCurrentDownLoads.getAt(tFile)) then
    return(error(me, "CastLoad task was lost!" && tFile && tID, #DoneCurrentDownLoad, #major))
  end if
  tTask = pTaskList.getaProp(tID)
  if tTask = void() then
    return(error(me, "Task list item was lost!" && tFile && tID, #DoneCurrentDownLoad, #major))
  end if
  if tstate <> #done then
    pLastError = netError(pCurrentDownLoads.getAt(tFile).pNetId)
  end if
  if tstate <> #error then
    tCastNumber = me.getAvailableEmptyCast()
    if tCastNumber > 0 then
      tCastName = tFile
      tPreIndexing = tTask.getIndexingAllowed()
      me.setImportedCast(tCastNumber, tCastName, tURL, tPreIndexing)
    end if
  end if
  tTask.OneCastDone(tFile)
  tTask.changeLoadingCount(-1)
  pCurrentDownLoads.getAt(tFile).deconstruct()
  me.delay(50, #removeCastLoadInstance, tFile)
  me.removeCastLoadTask(tID, tstate)
  return(1)
  exit
end

on removeCastLoadInstance(me, tFile)
  if tFile.ilk <> #string then
    return(0)
  end if
  if voidp(pCurrentDownLoads.getAt(tFile)) then
    return(error(me, "CastLoad instance was lost!" && tFile, #removeCastLoadInstance, #minor))
  else
    return(pCurrentDownLoads.deleteProp(tFile))
  end if
  exit
end

on removeCastLoadTask(me, tID, tstate)
  tTask = pTaskList.getaProp(tID)
  if tstate = #failed then
    tTask.setFailed()
  end if
  if tTask.getTaskState() = #ready then
    if tTask.getFailed() then
      tstate = #failed
    end if
    tTask.DoCallBack(tstate)
    tTask.deconstruct()
    pTaskList.deleteProp(tID)
    if count(pTaskList) = 0 then
      removePrepare(me.getID())
    end if
  end if
  exit
end

on TellStreamState(me, tFileName, tstate, tPercent, tID)
  startProfilingTask("CastLoad Manager::tellStreamState")
  tObject = pTaskList.getaProp(tID)
  if tObject <> void() then
    call(#UpdateTaskPercent, tObject, tPercent, tFileName)
  else
    return(error(me, "Task list instance was lost!" && tFileName && tID, #TellStreamState, #major))
  end if
  finishProfilingTask("CastLoad Manager::tellStreamState")
  exit
end

on setImportedCast(me, tCastNum, tCastName, tFileName, tDoIndexing)
  startProfilingTask("CastLoad Manager::setImportedCast " & tCastName)
  tCastLib = castLib(tCastNum)
  if voidp(tDoIndexing) then
    tDoIndexing = 1
  end if
  if tCastLib.name contains pNullCastName then
    tCastLib.fileName = tFileName
    tCastLib.name = tCastName
    pPermanentLevelList.getAt(tCastName).setAt(2, tCastNum)
    if tDoIndexing then
      getResourceManager().preIndexMembers(tCastNum)
    end if
    pLoadedCasts.setAt(tCastName, string(tCastNum))
  end if
  me.verifyReset()
  finishProfilingTask("CastLoad Manager::setImportedCast " & tCastName)
  exit
end

on getAvailableEmptyCast(me)
  if pAvailableDynCasts.count > 0 then
    tCastNum = pAvailableDynCasts.getLast()
    pAvailableDynCasts.deleteAt(pAvailableDynCasts.count)
    return(tCastNum)
  else
    SystemAlert(me, "Out of free cast entries! CastLoad failed.")
    return(0)
  end if
  exit
end

on removeTemporaryCast(me, tNewLoadListOfcasts)
  tTempList = pPermanentLevelList.duplicate()
  f = 1
  repeat while f <= tTempList.count
    tPermanent = tTempList.getAt(f).getAt(1)
    tCstNumber = tTempList.getAt(f).getAt(2)
    if tPermanent = 0 and tCstNumber > 0 then
      tCastName = tTempList.getPropAt(f)
      if not tNewLoadListOfcasts.getOne(tCastName) then
        pPermanentLevelList.deleteProp(tCastName)
        me.ResetOneDynamicCast(tCstNumber)
        if pCastLibCount <> the number of undefineds then
          pCastLibCount = the number of undefineds
          tError = "CastLib count was changed!!!" & "\r"
          tError = tError & "CastLib with problems:" && castLib(pCastLibCount).name
          error(me, tError, #removeTemporaryCast, #minor)
        end if
      end if
    end if
    f = 1 + f
  end repeat
  exit
end

on addOneCastToWaitList(me, tCastName, tPermanentOrNot)
  if not me.FindCastNumber(tCastName) and not pWaitList.getOne(tCastName) then
    pTempWaitList.add(tCastName)
    tOffset = offset("?", tCastName)
    if tOffset <> 0 then
      tCastNameNoParams = tCastName.getProp(#char, 1, tOffset - 1)
    else
      tCastNameNoParams = tCastName
    end if
    pPermanentLevelList.addProp(tCastNameNoParams, [tPermanentOrNot, 0])
  else
    if voidp(pLoadedCasts.getAt(tCastName)) then
      pLoadedCasts.setAt(tCastName, string(me.FindCastNumber(tCastName)))
    end if
  end if
  exit
end

on ResetOneDynamicCast(me, tCastNum)
  if pLoadedCasts.getOne(string(tCastNum)) <> 0 then
    pLoadedCasts.deleteProp(pLoadedCasts.getOne(string(tCastNum)))
  else
    error(me, "Couldn't remove cast:" && tCastNum, #ResetOneDynamicCast, #minor)
  end if
  getThreadManager().closeThread(tCastNum)
  getResourceManager().unregisterMembers(tCastNum)
  castLib(tCastNum).name = pNullCastName && tCastNum - 2
  castLib(pNullCastName && tCastNum - 2).fileName = getMoviePath() & pNullCastName & pFileExtension
  pAvailableDynCasts.addProp(pNullCastName & tCastNum - 2, tCastNum)
  return(1)
  exit
end

on verifyReset(me)
  tEmptyCastNum = 1
  repeat while tEmptyCastNum <= the number of undefineds
    if castLib(tEmptyCastNum).fileName contains pNullCastName then
      if the number of castMembers > 0 then
        fatalError(["error":"empty_cast_failure"])
        return(0)
      end if
    end if
    tEmptyCastNum = 1 + tEmptyCastNum
  end repeat
  exit
end

on solveNetErrorMsg(me, tErrorCode)
  if me = "" then
    return("Unknown error.")
  else
    if me = "OK" then
      return("OK")
    else
      if me = -128 then
        return("Operation was cancelled.")
      else
        if me = 0 then
          return("OK")
        else
          if me = 4 then
            return("Bad MOA Class. Network Xtras may be improperly installed.")
          else
            if me = 5 then
              return("Bad MOA Interface. Network Xtras may be improperly installed.")
            else
              if me = 6 then
                return("General transfer error.")
              else
                if me = 20 then
                  return("Internal error.")
                else
                  if me = 900 then
                    return("Failed attempt to write to locked media.")
                  else
                    if me = 903 then
                      return("Disk is full.")
                    else
                      if me = 905 then
                        return("Bad URL.")
                      else
                        if me = 4144 then
                          return("Failed network operation.")
                        else
                          if me = 4145 then
                            return("Failed network operation.")
                          else
                            if me = 4146 then
                              return("Connection could not be established with the remote host.")
                            else
                              if me = 4147 then
                                return("Failed network operation.")
                              else
                                if me = 4148 then
                                  return("Failed network operation.")
                                else
                                  if me = 4149 then
                                    return("Data supplied by the server was in an unexpected format.")
                                  else
                                    if me = 4150 then
                                      return("Unexpected early closing of connection.")
                                    else
                                      if me = 4151 then
                                        return("Failed network operation.")
                                      else
                                        if me = 4152 then
                                          return("Data returned is truncated.")
                                        else
                                          if me = 4153 then
                                            return("Failed network operation.")
                                          else
                                            if me = 4154 then
                                              return("Operation could not be completed due to timeout.")
                                            else
                                              if me = 4155 then
                                                return("Not enough memory available to complete the transaction.")
                                              else
                                                if me = 4156 then
                                                  return("Protocol reply to request indicates an error in the reply.")
                                                else
                                                  if me = 4157 then
                                                    return("Transaction failed to be authenticated.")
                                                  else
                                                    if me = 4159 then
                                                      return("Invalid URL.")
                                                    else
                                                      if me = 4160 then
                                                        return("Failed network operation.")
                                                      else
                                                        if me = 4161 then
                                                          return("Failed network operation.")
                                                        else
                                                          if me = 4162 then
                                                            return("Failed network operation.")
                                                          else
                                                            if me = 4163 then
                                                              return("Failed network operation.")
                                                            else
                                                              if me = 4164 then
                                                                return("Could not create a socket")
                                                              else
                                                                if me = 4165 then
                                                                  return("Requested Object could not be found (URL may be incorrect).")
                                                                else
                                                                  if me = 4166 then
                                                                    return("Generic proxy failure.")
                                                                  else
                                                                    if me = 4167 then
                                                                      return("Transfer was intentionally interrupted by client.")
                                                                    else
                                                                      if me = 4168 then
                                                                        return("Failed network operation.")
                                                                      else
                                                                        if me = 4242 then
                                                                          return("Download stopped by netAbort(url).")
                                                                        else
                                                                          if me = 4836 then
                                                                            return("Cache download stopped for an unknown reason.")
                                                                          else
                                                                            return("Other network error:" && tErrorCode)
                                                                          end if
                                                                        end if
                                                                      end if
                                                                    end if
                                                                  end if
                                                                end if
                                                              end if
                                                            end if
                                                          end if
                                                        end if
                                                      end if
                                                    end if
                                                  end if
                                                end if
                                              end if
                                            end if
                                          end if
                                        end if
                                      end if
                                    end if
                                  end if
                                end if
                              end if
                            end if
                          end if
                        end if
                      end if
                    end if
                  end if
                end if
              end if
            end if
          end if
        end if
      end if
    end if
  end if
  exit
end

on handlers()
  return([])
  exit
end